<?php
/*
Plugin Name: WP App Store Connect
Plugin URI: http://softcontent.eu
Description: Creates a shortcode to display some iTunes info about an app
Version: 0.9
Author: Kai Fenner
Author URI: http://softcontent.eu
CSS-Code Sliding Photograph Galleries by stu nicholls - cssplay.co.uk
License: GPL2
*/

/*  Copyright 2012  Kai Fenner (email : kai@appdamit.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

	global $wp_version;
	if (version_compare($wp_version, "2.6", "<")) {
		  exit('WP App Store Connect require WordPress 2.6 or newer. <a href="http://codex.wordpress.org/Upgrading_WordPress">Please update!</a>');
	  }

	# Avoid name collisions.
	if (!class_exists('WP_App_Store_Connect')) {
	  class WP_App_Store_Connect
	  {
		  # this variable will hold url to the plugin  
		  var $plugin_url;
		  
		  # name for our options in the DB
		  var $db_option = 'WP_App_Store_Connect_Options';

          # Initialize the plugin
          function WP_App_Store_Connect()
          {
              $this->plugin_url = trailingslashit( WP_PLUGIN_URL . '/' .dirname ( plugin_basename(__FILE__) ) );
              
              # add shortcode handler
              add_shortcode('appstore', array(&$this, 'AppStoreInfos'));
              
              # add options Page
              add_action('admin_menu', array(&$this, 'admin_menu'));
			  
			  # add CSS stylesheet
			  add_action('wp_enqueue_scripts', array(&$this, 'add_my_stylesheet'));
              
          }
		  
          # hook the options page
          function admin_menu()
          {
              add_options_page('WP App Store Connect Options', 'WP App Store Connect', 8, basename(__FILE__), array(&$this, 'handle_options'));
          }

          function scripts_action()
          {
              $options = $this->get_options();
              
          }

          # handle plugin options
          function get_options()
          {
              # default values
              $options = array(
					'storecountry' => 'US',
					'style' => 'infobox',
					'affiliateid' => '',
					'stylefull' =>
'<table border=1 background=white>
<tr>
<td>
<h2>APPNAME</h2>
by DEVNAME<br>
ITUNESLINK<br>
UNIVERSALAPP
<b>PRICE CURRENCY</b><br>
</td>
<td>
APPICON<175>
</td>
<tr>
<td colspan=2>
Category: CATEGORIES<br>
Updated: RELEASEDATE<br>
Version: VERSION<br>
Size: FILESIZE<br>
Languages: LANGUAGES<br>
Rated: CONTENTRT<br>
Requirements: SUPPORTED<br>
Customer ratings: RATING<br>
</td>
</tr>
</table>
<p>DESCRIPTION</p>
<p>RELEASENOTES</p>
SCREENSHOTS',
					
					'styleinfobox' => 
'<table border=1 background=white>
<tr>
<td>
<h2>APPNAME</h2>
by DEVNAME<br>
ITUNESLINK<br>
UNIVERSALAPP
<b>PRICE CURRENCY</b><br>
</td>
<td>
APPICON<175>
</td>
<tr>
<td colspan=2>
Category: CATEGORIES<br>
Updated: RELEASEDATE<br>
Version: VERSION<br>
Size: FILESIZE<br>
Languages: LANGUAGES<br>
Rated: CONTENTRT<br>
Requirements: SUPPORTED<br>
Customer ratings: RATING<br>
</td>
</tr>
</table>
SCREENSHOTS',

					'stylesmallbox' =>
'<table border=1 background=white>
<tr>
<td>
<h2>APPNAME</h2>
by DEVNAME<br>
ITUNESLINK<br>
UNIVERSALAPP
<b>PRICE CURRENCY</b><br>
Customer ratings: RATING
</td>
<td>
APPICON<90>
</td>
</table>',

					'stylecustombox1' =>  '',
					'stylecustombox2' =>  '',
					'stylecustombox3' =>  ''

					);
			  
              # get saved options
              $saved = get_option($this->db_option);
              
              # assign them
              if (!empty($saved)) {
                  foreach ($saved as $key => $option)
                      $options[$key] = $option;
              }
              
              # update the options if necessary
              if ($saved != $options)
                  update_option($this->db_option, $options);
              
              # return the options  
              return $options;
          }
          
          # Set up everything
          function install()
          {
              # set default options
              $this->get_options();
          }

          # handle the admin options page
          function handle_options()
          {
              $options = $this->get_options();
              
              if (isset($_POST['submitted'])) {
              		
              	  # check security
              	  check_admin_referer('wp-app-store-connect-nonce');
              		
				  # update option
				  $options = array();
                  $options['storecountry'] = $_POST['storecountry'];
                  $options['style'] = $_POST['style'];
                  $options['affiliateid'] = $_POST['affiliateid'];
                  $options['stylefull'] = $_POST['stylefull'];
                  $options['styleinfobox'] = $_POST['styleinfobox'];
                  $options['stylesmallbox'] = $_POST['stylesmallbox'];
                  $options['stylecustombox1'] = $_POST['stylecustombox1'];
                  $options['stylecustombox2'] = $_POST['stylecustombox2'];
                  $options['stylecustombox3'] = $_POST['stylecustombox3'];
                  update_option($this->db_option, $options);
                  
                  echo '<div class="updated fade"><p>Plugin settings saved.</p></div>';

			  }
              
			  # store options
              $storecountry = $options['storecountry'];
              $style = $options['style'];
              $affiliateid = $options['affiliateid'];
              $stylefull = $options['stylefull'];
              $styleinfobox = $options['styleinfobox'];
              $stylesmallbox = $options['stylesmallbox'];
              $stylecustombox1 = $options['stylecustombox1'];
              $stylecustombox2 = $options['stylecustombox2'];
              $stylecustombox3 = $options['stylecustombox3'];

              # URL for form submit, equals our current page
              $action_url = $_SERVER['REQUEST_URI'];

              # include admin page
			  include(plugin_dir_path( __FILE__ ) . 'admin.php');
          }		  
		  
		  # main function to retrieve app store data
		  function AppStoreInfos($atts){

				# plugin directory
				$myDir = plugins_url('/', __FILE__);;

				# load constants for country codes and supported devices
				include plugin_dir_path( __FILE__ ) . 'constants.php';

				# get plugin options from admin page
			  $options = $this->get_options();

			  # get options from shortcode
			  extract(shortcode_atts( array(
					'id' => "343200656", # in case app id is omitted
					'store' => $options['storecountry'],
					'style' => $options['style']
				), $atts ));

				# store is
				# -> from shortcode
				# -> if omitted from admin options
				# -> if omitted = 'US'
				if ($store == '') {$store = 'US';}

				# get html-template based on selected style
				# -> from shortcode
				# -> if omitted from admin options
				# -> if omitted = 'infobox'

				switch ($style) {
					case "full";
						$html = $options['stylefull'];
						break;
					case "smallbox";
						$html = $options['stylesmallbox'];
						break;
					case "custombox1";
						$html = $options['stylecustombox1'];
						break;
					case "custombox2";
						$html = $options['stylecustombox2'];
						break;
					case "custombox3";
						$html = $options['stylecustombox3'];
						break;
					default;
						$html = $options['styleinfobox'];
				  }
				
				# get the iTunes data 
				$search_term = 'id=' .  $id;
				$search_term = $search_term . '&country=' . $store;
				$app_url = 'http://itunes.apple.com/lookup?' . $search_term;
				$itunes_data = trim($this->get_content ($app_url));

				# decode the JSON string returned 
				# http://jsonformatter.curiousconcept.com/
				$itunes_data = json_decode("$itunes_data",true);

				# retrieve data from array
				$data = array(
				"CURRENCY" => $itunes_data["results"][0]["currency"],
				"PRICE" => $itunes_data["results"][0]["price"],
				"DEVNAME" => '<a href="' . $itunes_data["results"][0]["sellerUrl"] . '" target="_blank">' . $itunes_data["results"][0]["artistName"] . '</a>',
				"artistiD" => $itunes_data["results"][0]["artistiD"],
				"VERSION" => $itunes_data["results"][0]["version"],
				"RELEASEDATE" => $itunes_data["results"][0]["releaseDate"],
				"FILESIZE" =>  round(($itunes_data["results"][0]["fileSizeBytes"] / 1048576 ), 2) . " MB",
				"contentAdvisoryRating" => $itunes_data["results"][0]["contentAdvisoryRating"],
				"sellerUrl" => $itunes_data["results"][0]["sellerUrl"],
				"RATING" => '<img src="' . $myDir . 'rating_' . ($itunes_data["results"][0]["averageUserRating"] * 2) . '.gif" width="55" height="11"> (' . $itunes_data["results"][0]["userRatingCount"] . ' Ratings)',
				"trackViewUrl" => $itunes_data["results"][0]["trackViewUrl"],
				"APPNAME" => $itunes_data["results"][0]["trackName"],
				"artworkUrl512" => $itunes_data["results"][0]["artworkUrl512"],
				"DESCRIPTION" => $itunes_data["results"][0]["description"],
				"CONTENTRT" => $itunes_data["results"][0]["contentAdvisoryRating"],
				"RELEASENOTES" => $itunes_data["results"][0]["releaseNotes"]
				);

				# Make affiliate link if a tradedoubler website id has been configured.
				# The syntax is
				# http://clkde.tradedoubler.com/click?p=23761&a=XXXXXX&url=iTunes Store URL&partnerId=2003
				# where 'XXXXXX' is the website id
				# and iTunes Store URL the link to the iTunes Srore item.
				$affiliateid = $options['affiliateid'];
				if ($affiliateid != "")
					{$data["trackViewUrl"] = 'http://clkde.tradedoubler.com/click?p=23761&a=' . $affiliateid . '&url=' . $data["trackViewUrl"] . '&partnerId=2003';}

				# app description
				$data["DESCRIPTION"] = preg_replace("/\\n/", "<br />",$data["DESCRIPTION"]);
				if ($store == "DE") {$data["DESCRIPTION"] = "<h3>Beschreibung " . $data["APPNAME"] . "</h3>" . $data["DESCRIPTION"];}
				else {$data["DESCRIPTION"] = "<h3>Description " . $data["APPNAME"] . "</h3>" . $data["DESCRIPTION"];}
				$data["DESCRIPTION"] = $this->linker($data["DESCRIPTION"]);
				
				# app release notes
				$data["RELEASENOTES"] = preg_replace("/\\n/", "<br />",$data["RELEASENOTES"]);
				if ($store == "DE") {$data["RELEASENOTES"] = "<h3>Neue Funktionen von Version ". $data["VERSION"] . "</h3>" . $data["RELEASENOTES"];}
				else {$data["RELEASENOTES"] = "<h3>What's New in Version ". $data["VERSION"] . "</h3>" . $data["RELEASENOTES"];}
				$data["RELEASENOTES"] = $this->linker($data["RELEASENOTES"]);

				# is universal app or not
				if (isset($itunes_data["results"][0]["features"]))
					{
					if (in_array("iosUniversal", $itunes_data["results"][0]["features"]))
						{
						$iosUniversal = '<img src="' . $myDir . 'universalapp.gif" width="10" height="10" title="universal app iPhone & iPad" alt="universal app iPhone & iPad">';
						if ($store == "DE") {$iosUniversal .= 'Diese App wurde sowohl f&uuml;r das iPhone als auch f&uuml;r das iPad konzipiert';}
						else {$iosUniversal .= 'This app is designed for both iPhone and iPad';}
						$iosUniversal .= '<br />';
						}
					}

				# app languages
				if (isset($itunes_data["results"][0]["languageCodesISO2A"])) {
				foreach ($itunes_data["results"][0]["languageCodesISO2A"] as $lang)
				{
					if ($country_codes[$lang])
						{
						$lang = $country_codes[$lang];
						if ($store == "DE") {$lang = preg_replace("/.*,/", "", $lang);}
						else {$lang = preg_replace("/,.*/", "", $lang);}
						}
					$languages .= $lang . ", ";
				}
				$languages = preg_replace("/, $/", "", $languages);
				}

				# app supported devices
				if (isset($itunes_data["results"][0]["supportedDevices"])) {
				foreach ($itunes_data["results"][0]["supportedDevices"] as $devices)
				{
					if ($supported_devices[$devices])
					{$supporteddevices .= $supported_devices[$devices] . ", ";}
					else {$supporteddevices .= $devices . ", ";}
				}
				$supporteddevices = preg_replace("/, $/", "", $supporteddevices);
				}
				
				# app categoried
				if (isset($itunes_data["results"][0]["genres"])) {
				foreach ($itunes_data["results"][0]["genres"] as $genre)
				{
					$genres .= $genre . ", ";
				}
				$genres = preg_replace("/, $/", "", $genres);
				}
				
				# link to app store
				if ($store == "DE") {$ituneslink = '<img src="' . $myDir . 'viewinitunes_de.png" width="126" height="23" title="in iTunes ansehen" alt="in iTunes ansehen">';}
				else {$ituneslink = '<img src="' . $myDir . 'viewinitunes_en.png" width="106" height="23" title="show in iTunes" alt="show in iTunes">';}
				$ituneslink = '<a href="' . $data["trackViewUrl"] . '" target="_blank">' . $ituneslink . '</a>';
				
				# app screenshots
				if (isset($itunes_data["results"][0]["screenshotUrls"]))
					{$screenshothtml .= $this->make_ImageGallery($itunes_data["results"][0]["screenshotUrls"], "galleryiPhone", $data['APPNAME']);}
				if (isset($itunes_data["results"][0]["ipadScreenshotUrls"]))
					{$screenshothtml .= $this->make_ImageGallery($itunes_data["results"][0]["ipadScreenshotUrls"], "galleryiPad", $data['APPNAME']);}

				# delimeters for preg_match
				foreach (array_keys($data) as $key)	{$searchpatterns[] = '/' . $key .'/' ;}

				# app icon
				if (preg_match("/APPICON<(\d.*?)>/", $html, $matches))
				{
				$artworksize = $matches[1];
				$artwork = '<img src="' . $data["artworkUrl512"] . '" width="' . $artworksize . '" height="' . $artworksize . '" title="' . $data['APPNAME'] . '" alt="' . $data['APPNAME'] . '">';
				}
				
				# put data in html template
				$html = preg_replace($searchpatterns, $data, $html);
				$html = preg_replace("/UNIVERSALAPP/", $iosUniversal, $html);
				$html = preg_replace("/ITUNESLINK/", $ituneslink, $html);
				$html = preg_replace("/SCREENSHOTS/", $screenshothtml, $html);
				$html = preg_replace("/APPICON<$artworksize>/", $artwork, $html);
				$html = preg_replace("/LANGUAGES/", $languages, $html);
				$html = preg_replace("/SUPPORTED/", $supporteddevices, $html);
				$html = preg_replace("/CATEGORIES/", $genres, $html);

				# that's it
				return $html;

			}

			# make image gallery
			function make_ImageGallery($screenShots, $gallerytype, $imagetitle) {

				# sometimes empty array
				if (count($screenShots) == 0) {return;}

				# captions for iPhone & iPad gallery
				if ($gallerytype == "galleryiPad")
					{
						$imagegallery = "<h3>Screenshots iPad</h3>";
						$imagetitle .= " iPad";
					}
				else
					{
						$imagegallery = "<h3>Screenshots iPhone</h3>";
						$imagetitle .= " iPhone";
					}
				
				# gallery starts with <ul>
				# it's basically an ordered list
				$imagegallery .= '<p><ul id="' . $gallerytype . '">';
				
				# make a <li> link for every image
				foreach ($screenShots as $image)
					{$imagegallery .= '<li><a href="#nolink"><img src="' . $image . '" alt="' . $imagetitle . ' " title="' . $imagetitle . '"></a></li>';}
				
				# closing </ul>
				$imagegallery .= '</ul></p>';
				
				# that's it
				return $imagegallery;

				}

			# read from file
			function get_content($url)
			{
				$ch = curl_init();

				curl_setopt ($ch, CURLOPT_URL, $url);
				curl_setopt ($ch, CURLOPT_HEADER, 0);

				ob_start();

				curl_exec ($ch);
				curl_close ($ch);
				$string = ob_get_contents();

				ob_end_clean();
				
				return $string;     
			}

			# enqueue style-file, if it exists.
			function add_my_stylesheet()
			{
				$myStyleUrl = plugins_url('style.css', __FILE__); // Respects SSL, Style.css is relative to the current file
				$myStyleFile = WP_PLUGIN_DIR . '/wp-app-store-connect/style.css';
				if ( file_exists($myStyleFile) ) {
					wp_register_style('myStyleSheets', $myStyleUrl);
					wp_enqueue_style( 'myStyleSheets');
				}
			}

			# convert plain text-links to clickable links
			function linker($link)
			{
			$link = str_replace("http://www.","www.",$link);
			$link = str_replace("www.","http://www.",$link);
			$link = preg_replace(
			"/([\w]+:\/\/[\w-?&;#~=\.\/\@]+[\w\/])/i","<a href=\"$1\" target=_blank>$1</a>", $link);
			$link = preg_replace(
			"/([\w-?&;#~=\.\/]+\@(\[?)[a-zA-Z0-9\-\.]+\.
			([a-zA-Z]{2,3}|[0-9]{1,3})(\]?))/i","<a href=\"mailto:$1\" target=_blank>$1</a>",$link);
			return $link;
			}

		}
	}
	else
	  { exit("Class WP_App_Store_Connect already declared!"); }

	// create new instance of the class
	$WP_App_Store_Connect = new WP_App_Store_Connect();
	if (isset($WP_App_Store_Connect)) {
	  // register the activation function by passing the reference to our instance
	  register_activation_hook(__FILE__, array(&$WP_App_Store_Connect, 'install'));
	}

?>